

#ifndef __RAW_NET_H__
#define __RAW_NET_H__


struct udp_80211_hdr {
    struct a4_80211		llh;
    struct llc_hdr		llc;
    struct ip			iph;
    struct udphdr		udph;
} __attribute__ ((packed));

struct udp_8023_hdr {
    struct ether_header	llh;
    struct ip			iph;
    struct udphdr		udph;
} __attribute__ ((packed));

struct pseudo_hdr {
    __u32	src_ip;
    __u32	dst_ip;
    __u8	zero;
    __u8	proto;
    __u16	len;
} __attribute__ ((packed));



#ifndef __RAW_NET_C__

/*** Prototypes ***/

extern size_t ip_encap (void *, size_t, __u32, __u32, __u8);
extern size_t ll8023_encap (void *, size_t, __u8 *, __u8 *, __u16);
extern size_t ll80211_encap (void *, size_t, __u8 *, __u8 *, __u8 *, __u16, __u8, __u8);
extern size_t udp_encap (void *, size_t, __u32, __u32, __u16, __u16);
extern void *ip_8023_payload (void *, size_t);
extern void *ip_80211_payload (void *, size_t);
extern void *udp_8023_payload (void *, size_t);
extern void *udp_80211_payload (void *, size_t);

/******************/

#endif /* #ifndef __RAW_NET_C__ */


#endif /* #ifndef __RAW_NET_H__ */





